
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>基于Java内存溢出的解决方法详解_java / iVAN</title>

    <meta name="description" content="基于Java内存溢出的解决方法详解_java 一.内存溢出类型1.java.lang.OutOfMemoryError: PermGen spaceJVM管理两种类型的内存,堆和非堆.堆是给开发人员用的上面说的就是,是在JVM启动时创建:非堆是留给JVM自己用的,用来存放类的信息的.它和堆不同,运行期内GC不会释放空间.如果web app用了大量的第三方jar或者应用有太多的class文件而恰好MaxPermSize设置较小,超出了也会导致这块内存的占用过多造成溢出,或者tomcat热部署时侯不会清理前面加载的环境,只会将context更改">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">基于Java内存溢出的解决方法详解_java</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>一、内存溢出类型<br /></strong>1、java.lang.OutOfMemoryError: PermGen space<br />JVM管理两种类型的内存，堆和非堆。堆是给开发人员用的上面说的就是，是在JVM启动时创建；非堆是留给JVM自己用的，用来存放类的信息的。它和堆不同，运行期内GC不会释放空间。如果web app用了大量的第三方jar或者应用有太多的class文件而恰好MaxPermSize设置较小，超出了也会导致这块内存的占用过多造成溢出，或者tomcat热部署时侯不会清理前面加载的环境，只会将context更改为新部署的，非堆存的内容就会越来越多。</p>
<p>PermGen space的全称是Permanent Generation space,是指内存的永久保存区域，这块内存主要是被JVM存放Class和Meta信息的,Class在被Loader时就会被放到PermGen space中，它和存放类实例(Instance)的Heap区域不同,GC(Garbage Collection)不会在主程序运行期对PermGen space进行清理，所以如果你的应用中有很CLASS的话,就很可能出现PermGen space错误，这种错误常见在web服务器对JSP进行pre compile的时候。如果你的WEB APP下都用了大量的第三方jar, 其大小超过了jvm默认的大小(4M)那么就会产生此错误信息了。<br />一个最佳的配置例子：(经过本人验证，自从用此配置之后，再未出现过tomcat死掉的情况)<br />set JAVA_OPTS=-Xms800m -Xmx800m -XX:PermSize=128M -XX:MaxNewSize=256m -XX:MaxPermSize=256m</p>
<p>2、java.lang.OutOfMemoryError: Java heap space<br />第一种情况是个补充，主要存在问题就是出现在这个情况中。其默认空间(即-Xms)是物理内存的1/64，最大空间(-Xmx)是物理内存的1/4。如果内存剩余不到40％，JVM就会增大堆到Xmx设置的值，内存剩余超过70％，JVM就会减小堆到Xms设置的值。所以服务器的Xmx和Xms设置一般应该设置相同避免每次GC后都要调整虚拟机堆的大小。假设物理内存无限大，那么JVM内存的最大值跟操作系统有关，一般32位机是1.5g到3g之间，而64位的就不会有限制了。<br />注意：如果Xms超过了Xmx值，或者堆最大值和非堆最大值的总和超过了物理内存或者操作系统的最大限制都会引起服务器启动不起来。<br /><strong>垃圾回收GC的角色<br /></strong>JVM调用GC的频度还是很高的，主要两种情况下进行垃圾回收：<br />当应用程序线程空闲；另一个是java内存堆不足时，会不断调用GC，若连续回收都解决不了内存堆不足的问题时，就会报out of memory错误。因为这个异常根据系统运行环境决定，所以无法预期它何时出现。<br />根据GC的机制，程序的运行会引起系统运行环境的变化，增加GC的触发机会。<br />为了避免这些问题，程序的设计和编写就应避免垃圾对象的内存占用和GC的开销。显示调用System.GC()只能建议JVM需要在内存中对垃圾对象进行回收，但不是必须马上回收，<br />一个是并不能解决内存资源耗空的局面，另外也会增加GC的消耗。<br /><strong>二、JVM内存区域组成<br /></strong>简单的说java中的堆和栈<br />java把内存分两种：一种是栈内存，另一种是堆内存<br />1。在函数中定义的基本类型变量和对象的引用变量都在函数的栈内存中分配；<br />2。堆内存用来存放由new创建的对象和数组<br />在函数（代码块）中定义一个变量时，java就在栈中为这个变量分配内存空间，当超过变量的作用域后，java会自动释放掉为该变量所分配的内存空间；在堆中分配的内存由java虚拟机的自动垃圾回收器来管理<br />堆的优势是可以动态分配内存大小，生存期也不必事先告诉编译器，因为它是在运行时动态分配内存的。缺点就是要在运行时动态分配内存，存取速度较慢；<br />栈的优势是存取速度比堆要快，缺点是存在栈中的数据大小与生存期必须是确定的无灵活性。<br /><strong>java堆分为三个区：New、Old和Permanent<br /></strong>GC有两个线程：<br />新创建的对象被分配到New区，当该区被填满时会被GC辅助线程移到Old区，当Old区也填满了会触发GC主线程遍历堆内存里的所有对象。Old区的大小等于Xmx减去-Xmn<br />java栈存放<br />栈调整：参数有+UseDefaultStackSize -Xss256K，表示每个线程可申请256k的栈空间<br />每个线程都有他自己的Stack<br /><strong>三、JVM如何设置虚拟内存<br /></strong>提示：在JVM中如果98％的时间是用于GC且可用的Heap size 不足2％的时候将抛出此异常信息。<br />提示：Heap Size 最大不要超过可用物理内存的80％，一般的要将-Xms和-Xmx选项设置为相同，而-Xmn为1/4的-Xmx值。<br />提示：JVM初始分配的内存由-Xms指定，默认是物理内存的1/64；JVM最大分配的内存由-Xmx指定，默认是物理内存的1/4。<br />默认空余堆内存小于40%时，JVM就会增大堆直到-Xmx的最大限制；空余堆内存大于70%时，JVM会减少堆直到-Xms的最小限制。因此服务器一般设置-Xms、-Xmx相等以避免在每次GC 后调整堆的大小。<br />提示：假设物理内存无限大的话，JVM内存的最大值跟操作系统有很大的关系。<br />简单的说就32位处理器虽然可控内存空间有4GB,但是具体的操作系统会给一个限制，<br />这个限制一般是2GB-3GB（一般来说Windows系统下为1.5G-2G，Linux系统下为2G-3G），而64bit以上的处理器就不会有限制了<br />提示：注意：如果Xms超过了Xmx值，或者堆最大值和非堆最大值的总和超过了物理内存或者操作系统的最大限制都会引起服务器启动不起来。<br />提示：设置NewSize、MaxNewSize相等，"new"的大小最好不要大于"old"的一半，原因是old区如果不够大会频繁的触发"主" GC ，大大降低了性能<br />JVM使用-XX:PermSize设置非堆内存初始值，默认是物理内存的1/64；<br />由XX:MaxPermSize设置最大非堆内存的大小，默认是物理内存的1/4。<br /><strong>解决方法：手动设置Heap size<br /></strong>修改TOMCAT_HOME/bin/catalina.bat<br />在“echo "Using CATALINA_BASE: $CATALINA_BASE"”上面加入以下行：<br />JAVA_OPTS="-server -Xms800m -Xmx800m -XX:MaxNewSize=256m"<br /><strong>四、性能检查工具使用<br /></strong>定位内存泄漏：<br />JProfiler工具主要用于检查和跟踪系统（限于Java开发的）的性能。JProfiler可以通过时时的监控系统的内存使用情况，随时监视垃圾回收，线程运行状况等手段，从而很好的监视JVM运行情况及其性能。<br />1. 应用服务器内存长期不合理占用，内存经常处于高位占用，很难回收到低位；<br />2. 应用服务器极为不稳定，几乎每两天重新启动一次，有时甚至每天重新启动一次；<br />3. 应用服务器经常做Full GC(Garbage Collection)，而且时间很长，大约需要30-40秒，应用服务器在做Full GC的时候是不响应客户的交易请求的，非常影响系统性能。<br />因为开发环境和产品环境会有不同，导致该问题发生有时会在产品环境中发生，通常可以使用工具跟踪系统的内存使用情况，在有些个别情况下或许某个时刻确实是使用了大量内存导致out of memory，这时应继续跟踪看接下来是否会有下降，<br />如果一直居高不下这肯定就因为程序的原因导致内存泄漏。<br /><strong>五、不健壮代码的特征及解决办法<br /></strong>1、尽早释放无用对象的引用。好的办法是使用临时变量的时候，让引用变量在退出活动域后，自动设置为null，暗示垃圾收集器来收集该对象，防止发生内存泄露。<br />对于仍然有指针指向的实例，jvm就不会回收该资源,因为垃圾回收会将值为null的对象作为垃圾，提高GC回收机制效率；<br />2、我们的程序里不可避免大量使用字符串处理，避免使用String，应大量使用StringBuffer，每一个String对象都得独立占用内存一块区域；<br />String str = "aaa";<br />String str2 = "bbb";<br />String str3 = str + str2;//假如执行此次之后str ,str2以后再不被调用,那它就会被放在内存中等待Java的gc去回收,程序内过多的出现这样的情况就会报上面的那个错误,建议在使用字符串时能使用StringBuffer就不要用String,这样可以省不少开销；<br />3、尽量少用静态变量，因为静态变量是全局的，GC不会回收的；<br />4、避免集中创建对象尤其是大对象，JVM会突然需要大量内存，这时必然会触发GC优化系统内存环境；显示的声明数组空间，而且申请数量还极大。<br />这是一个案例想定供大家警戒<br />使用jspsmartUpload作文件上传,运行过程中经常出现java.outofMemoryError的错误，<br />检查之后发现问题：组件里的代码<br />m_totalBytes = m_request.getContentLength();<br />m_binArray = new byte[m_totalBytes];<br />问题原因是totalBytes这个变量得到的数极大，导致该数组分配了很多内存空间，而且该数组不能及时释放。解决办法只能换一种更合适的办法，至少是不会引发outofMemoryError的方式解决。<br />5、尽量运用对象池技术以提高系统性能；生命周期长的对象拥有生命周期短的对象时容易引发内存泄漏，例如大集合对象拥有大数据量的业务对象的时候，可以考虑分块进行处理，然后解决一块释放一块的策略。<br />6、不要在经常调用的方法中创建对象，尤其是忌讳在循环中创建对象。可以适当的使用hashtable，vector 创建一组对象容器，然后从容器中去取那些对象，而不用每次new之后又丢弃<br />7、一般都是发生在开启大型文件或跟数据库一次拿了太多的数据，造成 Out Of Memory Error 的状况，这时就大概要计算一下数据量的最大值是多少，并且设定所需最小及最大的内存空间值。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 06:31:57</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e5%86%85%e5%ad%98%e6%ba%a2%e5%87%ba/" title="内存溢出">内存溢出</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>基于Java内存溢出的解决方法详解_java的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwqaG8M.html" rel="bookmark">基于java涉及父子类的异常详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java中的异常涉及到父子类的问题,可以归纳为一句话:子类的构造函数抛出的异常必须包含父类的异常,子类的方法可以选择抛出&quot;范围小于等于&quot;父类的异常或不抛出异常. 1. 为什么构造函数必须抛出包含父类的异常? 在&lt;thingking in java&gt;中有这么一段话: 异常限制:当覆盖方法时,只能抛出在基类方法的异常说明中列出的那些异常 异常限制对构造器不起作用,你会发现StormyInning的构造器可以抛出任何异常,而不必理会基类构造函数所抛出的异常.然而因为必须构造函数必			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdm0DNz.html" rel="bookmark">java中set接口使用方法详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java中的set接口有如下的特点: 不允许出现重复元素: 集合中的元素位置无顺序: 有且只有一个值为null的元素. 因为java中的set接口模仿了数学上的set抽象,所以,对应的数学上set的特性为: 互异性:一个集合中,任何两个元素都认为是不相同的,即每个元素只能出现一次.无序性:一个集合中,每个元素的地位都是相同的,元素之间是无序的.集合上可以定义序关系,定义了序关系后,元素之间就可以按照序关系排序.但就集合本身的特性而言,元素之间没有必然的序.空集的性质:空集是一切集合的子集    			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEYda3b.html" rel="bookmark">基于序列化存取实现java对象深度克隆的方法详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们知道,在java中,将一个非原型类型类型的对象引用,赋值给另一个对象的引用之后,这两个引用就指向了同一个对象,如: 复制代码 代码如下: public class DeepCloneTest {  private class CloneTest {  private Long myLong = new Long(1); }  public static void main(String args[]) {  new DeepCloneTest().Test(); }  public void			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvYmP8b.html" rel="bookmark">基于Java HashMap的死循环的启示详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.单线程改造为多线程也是个技术活 正如我们看到耗子叔叔博客里写的那样,原来是单线程的应用程序,&quot;后来,我们的程序性能有问题,所以需要变成多线程的,于是,变成多线程后到了线上,发现程序经常占了100%的CPU&quot;. 考虑到是淘宝的工程师曝出来的问题,他们的技术基础一般都很扎实,连他们都用错了,所以把单线程改造为多线程并不是想象中的那么简单,我认为. 你可能很不服气地反问,淘宝的工程师又怎么了,单线程改为多线程有什么难的?无非就是应用现有的多线程技术嘛,你看,我有非常强烈的线程安全意识,我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOaZw3M.html" rel="bookmark">JAVA获取CLASSPATH路径的方法详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ClassLoader 提供了两个方法用于从装载的类路径中取得资源: public URL getResource (String name); public InputStream getResourceAsStream (String name);        这里name是资源的类路径,它是相对与&quot;/&quot;根路径下的位置.getResource得到的是一个URL对象来定位资源,而getResourceAsStream取得该资源输入流的引用保证程序可以从正确的位置抽取数据.     			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEYOgob.html" rel="bookmark">Java的枚举类型使用方法详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.背景在java语言中还没有引入枚举类型之前,表示枚举类型的常用模式是声明一组具有int常量.之前我们通常利用public final static 方法定义的代码如下,分别用1 表示春天,2表示夏天,3表示秋天,4表示冬天. public class Season { public static final int SPRING = 1; public static final int SUMMER = 2; public static final int AUTUMN = 3; publi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXKWW5M.html" rel="bookmark">java&period;util&period;ArrayDeque类使用方法详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文为大家介绍了java.util.ArrayDeque类使用方法,供大家参考,具体内容如下 1. ArrayDeque有两个类属性,head和tail,两个指针. 2. ArrayDeque通过一个数组作为载体,其中的数组元素在add等方法执行时不移动,发生变化的只是head和tail指针,而且指针是循环变化,数组容量不限制. 3. offer方法和add方法都是通过其中的addLast方法实现,每添加一个元素,就把元素加到数组的尾部,此时,head指针没有变化,而tail指针加一,因为指针是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3Zkagz.html" rel="bookmark">基于Java回顾之JDBC的使用详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				尽管在实际开发过程中,我们一般使用ORM框架来代替传统的JDBC,例如Hibernate或者iBatis,但JDBC是Java用来实现数据访问的基础,掌握它对于我们理解Java的数据操作流程很有帮助. JDBC的全称是Java Database Connectivity. JDBC对数据库进行操作的流程:•连接数据库•发送数据请求,即传统的CRUD指令•返回操作结果集JDBC中常用的对象包括:•ConnectionManager•Connection•Statement•CallableStat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNk3Zp.html" rel="bookmark">基于Java 注解&lpar;Annotation&rpar;的基本概念详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				什么是注解(Annotation): Annotation(注解)就是Java提供了一种元程序中的元素关联任何信息和着任何元数据(metadata)的途径和方法.Annotion(注解)是一个接口,程序可以通过反射来获取指定程序元素的Annotion对象,然后通过Annotion对象来获取注解里面的元数据. Annotation(注解)是JDK5.0及以后版本引入的.它可以用于创建文档,跟踪代码中的依赖性,甚至执行基本编译时检查.从某些方面看,annotation就像修饰符一样被使用,并应用于包			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdXApj.html" rel="bookmark" class="title">十款提高开发效率的Firefox插件</a>
					<div>
						  Firefox浏览器能成为Web开发者和设计者最喜欢的浏览器,一个重要原因就是它有着丰富的插件可以用来辅助我们完成Web开发工作.下面给大家分享十款在Web开发工作中经常会用到的插件,利用好它们可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPWJlM.html" rel="bookmark" class="title">PHP新手上路（十四）</a>
					<div>
						13.1 生成图像 PHP可以操作处理图像.如果你已经安装了GD库,你甚至可以利用PHP生成图像. &lt;? Header(&quot;Content-type: image/gif&quot;); ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zemYVz.html" rel="bookmark" class="title">利用XML开发留言板简单的例子</a>
					<div>
						xml XML是一种基于文本格式的元标记语言,它注重对数据结构和数据意义的描述,实现了数据内容和显示样式的分离(xml+xsl),而且是与平台无关的. 由于XML注重数据内容的描述,因而,对于数据的检 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMl4mRM.html" rel="bookmark" class="title">当踏入站长界那一刻，你应该做哪些准备？</a>
					<div>
						一.自食其力 这是一个冷漠的群体,在没厉害之前没人会跟你分享和交流,更不会有人会来帮助你, 二.亲情.爱情.友情 1:亲情: 大多数站长应该都在30左右,而你的家长可能连网络都不知道是什么,他们辛辛苦 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMy8dPb.html" rel="bookmark" class="title">推荐：监测你的SQL Server让瓶颈暴露</a>
					<div>
						server|sql 当您怀疑计算机硬件是影响SQL Server运行性能的主要原因时,可以通过SQL Server Performance Monitor监视相应硬件的负载,以证实您的猜测并找出系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzwkqkz.html" rel="bookmark" class="title">原创文章的理解形式到底有几种</a>
					<div>
						百度当天就可以收录新站方式和经历关于老鸟站长们来说兴许不是什么稀奇的事件,但关于大局部的老手站长来说,可以是一个很艰难的题目.一个新站关于老手站长,兴许须要15天赋可以被百度收录,即使是很优良的网站也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5A7PBp.html" rel="bookmark" class="title">Photoshop制作凹槽的纹理金属字</a>
					<div>
						教程介绍比较独特的金属字制作方法.虽然字体效果用图层样式就可以完成.不过作者力求完美,特意加强了纹理的凹凸感,并加上了一些装饰的铆钉和纹理.效果看上去更加完美. 最终效果  1.创建一个800 × 6 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArmy2p.html" rel="bookmark" class="title">小米电视2s怎么看电视直播</a>
					<div>
						  小米电视2s为用户全面提供超过30万小时的央视正版授权高清内容,包含最新最热的电影.电视剧.综艺节目.动漫等等.同时特有追剧功能,可收藏你关注的热播剧集,不错过任何最新动态. 小米电视2s看电视直 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1aoWb.html" rel="bookmark" class="title">电脑右下角弹窗关不掉怎么办</a>
					<div>
						  这里我以W7系统与360杀毒软件为例,给大家提供一套方法 步骤一:首先我们打开360 杀毒软件 如图 步骤二:点击&quot;功能大全&quot; 如图 步骤三:点击&quot;电脑救援&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjXkWb.html" rel="bookmark" class="title">360公司宣布面向4亿用户推出&OpenCurlyDoubleQuote;网购先赔&rdquo;服务</a>
					<div>
						中国证券网讯(记者 李小兵)国内最大的网络安全厂商360公司宣布面向4亿用户推出&quot;网购先赔&quot;服务,承诺360安全卫士用户如因网购木马及钓鱼网站造成财产损失,360公司将为用户提供最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Z349b.html" rel="bookmark" class="title">yum工具 源代码-yum工具的源码在哪里可以找到？</a>
					<div>
						问题描述 yum工具的源码在哪里可以找到? 想对Linux下yum软件更新工具进行修改,请问其源代码可以在哪里得到?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My32xdz.html" rel="bookmark" class="title">《R语言游戏数据分析与挖掘》一3&period;3　高级绘图函数</a>
					<div>
						3.3 高级绘图函数 大部分高级绘图函数均有add参数(plot函数没有).如果add=FALSE(默认),则在新窗口中创建一个图形:如果add=TRUE,则在当前活动窗口中的原有图形之上叠加图形.在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQgxLp.html" rel="bookmark" class="title">C语言里的左移和右移运算</a>
					<div>
						先说左移,左移就是把一个数的所有位都向左移动若干位,在C中用&lt;&lt;运算符.例如: int i = 1;i = i &lt;&lt; 2; //把i里的值左移2位 也就是说,1的2进制是000 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mxo3eyb.html" rel="bookmark" class="title">Maven中的WEB工程转换为MyEclipse中的WEB工程（自动部署，调试）</a>
					<div>
						下面有两个方法,方法1是我从别人的网页上看的,方法2是我自己总结的,个人感觉方法2更便捷.哪个好用大家自己体会吧.   方法1.简要步骤如下: 0. 为eclipse添加Maven2和MyEclips ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKR4Db.html" rel="bookmark" class="title">学习asp&period;net看什么书好</a>
					<div>
						问题描述 我对asp有一定的了解,现在想学asp.net不知道怎么下手,想弄本书看,但是外面的书太多了,不知道选那本好,希望各位大哥大姐能帮帮我,推荐几本好书给小弟看看 解决方案 解决方案二:&lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd3ldb.html" rel="bookmark" class="title">《中国人工智能学会通讯》&mdash;&mdash;8&period;23 基于演化优化的网络结构平衡分析</a>
					<div>
						8.23 基于演化优化的网络结构平衡分析 结构平衡是网络结构分析中的一个重要概念[28] .分析网络结构平衡可以帮助我们深入研究网络中个体之间的联系,理解复杂系统由非平衡状态向平衡状态的动态进化.网络 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAEeXM.html" rel="bookmark" class="title">开源工具高效分析Java应用</a>
					<div>
						开源工具高效分析Java应用 不止一次,我们都萌发过想对运行中程序的底层状况一探究竟的念头.产生这种需求的原因可能是运行缓慢的服务.Java虚拟机(JVM)崩溃.挂起.死锁.频繁的JVM暂停.突然或持 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1reAjp.html" rel="bookmark" class="title">关于远程复制，急！！！！</a>
					<div>
						问题描述 请教个关于远程复制和粘贴的问题,即:用机器A管理操作机器B的硬盘,拷贝文件到B,或从B复制文件.试过WMI,不知道什么原因,总拒绝访问.用api可否实现?还有没有其他好的解决方案?我想实现的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNjWr7M.html" rel="bookmark" class="title">想在Windows 10中运行openSUSE？请参照此安装方法</a>
					<div>
						最近几个 Windows 10 编译版本中带来了一套完整的.基于 Ubuntu 的 Bash Shell,以便开发者们可以直接在 Windows 桌面上运行 Linux 软件或命令,它就是&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZaGap.html" rel="bookmark" class="title">mysql-大神求解，初学java，</a>
					<div>
						问题描述 大神求解,初学java, 在java中创建一个方法,调用方法之后需要从方法中返回两个数组,怎样才能办到 解决方案 方式有很多种, 1.二维数组的方式 2.Vector(不定长数组)嵌套的方式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodmWDM.html" rel="bookmark" class="title">谷歌收购Webpass提升网速 创建更好的互联网</a>
					<div>
						互联网搜索引擎巨头谷歌公司刚刚收购了一家名不见经传的互联网服务提供商,名叫Webpass.谷歌这一举动是为了扩展自己的超高速网络连接服务Google Fiber.但这次收购的一个小细节却向我们揭示了谷 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwrwmM.html" rel="bookmark" class="title">iis问题</a>
					<div>
						问题描述 装了iis后,登陆localhost要输入用户名和密码,怎么解决? 解决方案 解决方案二:你在你的Internet信息服务里面右键你的项目属性目录安全性:匿名访问和身份验证控制[编辑]把那个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwlQ5M.html" rel="bookmark" class="title">《C&plus;&plus;编程风格（修订版）》&mdash;&mdash;2&period;7　编程风格示例：第二种方法</a>
					<div>
						2.7 编程风格示例:第二种方法 C++编程风格(修订版) 我们暂时先不去考虑去解决 string 类中的其他问题,而是将注意力转移到另一个不同的字符 串类.在这个类中,我们避免了大多数的上述问题.我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAXxdb.html" rel="bookmark" class="title">C&num; webservice如何防止盗链问题</a>
					<div>
						问题描述 就是不能让用户输入比如http://192.178.1.188:8080/image/s.jpg就能下载到这个图片?不能让用户输入这个直接就下载怎么防止下?求代码急 解决方案 解决方案二:一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNv1QyM.html" rel="bookmark" class="title">美铝旗下Jamalco氧化铝精炼厂正常运转</a>
					<div>
						美铝周四表示,因受飓风袭击于8月20日关闭的Jamalco氧化铝精炼厂已开始正常生产,但因有损坏,生产水平有所缩减.该精炼厂位于牙买加的Clarendon,年产能为140万吨. 美铝发言人Kevin  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqRBWp.html" rel="bookmark" class="title">php使用ffmpeg获取视频信息并截图的实现方法&lowbar;php技巧</a>
					<div>
						本文实例讲述了php使用ffmpeg获取视频信息并截图的方法.分享给大家供大家参考,具体如下: $movie = new ffmpeg_movie('4.mp4'); $width=$movie-&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKm6vM.html" rel="bookmark" class="title">CentOS7编译安装新版LNMP环境&lowbar;Linux</a>
					<div>
						由于公司要求需要最新版的ZABBIX2.4.4需要最新版的系统CENTOS7和新版的LNMP环境,所以本人摸索着使用新版的环境搭建了LNMP系统,环境版本如下: 系统:CentOS 7 x86_64  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9NEy4p.html" rel="bookmark" class="title">第十六次计算机和移动终端病毒疫情调查活动在京启动</a>
					<div>
						为进一步宣传.普及信息网络安全知识,提高广大用户网络安全防范意识,同时给国家有关部门制定网络安全及计算机病毒防治策略提供准确参考,在公安部网络安全保卫局的指导下,2017年3月17日,第十六次计算机和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6YyZyb.html" rel="bookmark" class="title">LinkedIn每秒新增2名用户 用户总数超过1&period;2亿</a>
					<div>
						北京时间8月5日消息,据国外http://www.aliyun.com/zixun/aggregation/31646.html&quot;&gt;媒体报道,职业社交网站LinkedIn CEO杰夫· ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6YBagb.html" rel="bookmark" class="title">ceph 参数说明&amp;lt&semi;转&amp;gt&semi;</a>
					<div>
						//path/to/socket指向某个osd的admin socket文件#&gt; ceph --admin-daemon {path/to/socket} config show | grep  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
